SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'catalog items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Cart class
	instanceVariableNames: 'lastCartId'!

Cart class
	instanceVariableNames: 'lastCartId'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:25'!
newWithCatalog: aCatalog
	
	^self new initializeWithCatalog: aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:31'!
= aCart
	
	^(items = aCart items) and: (catalog = aCart catalog)! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:33'!
add: anItem
	
	self add: anItem withOccurrences: 1.
	^anItem ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 12:11'!
add: anItem withOccurrences: numberOfOccurrences
	
	(numberOfOccurrences > 0)
		ifTrue:[
				( catalog includes: anItem ) 
					ifTrue: [ items add: anItem withOccurrences: numberOfOccurrences]
					ifFalse: [ self error: 'Item is not present in the catalog. It cannot be added.' ].
				]
		ifFalse:  [self error: 'Invalid number of occurrences. It cannot be added.' ].
		
	^anItem! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:35'!
amountOf: anItem 
	
	^items occurrencesOf: anItem ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:37'!
catalog 
	
	^catalog copy.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:16'!
hash
	
	^((items hash) + (catalog hash)) hash ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 11:46'!
initializeWithCatalog: aCatalog
	"The only requirement on aCatalog is that it must know the message includes"	
	
	catalog := aCatalog.
	items := OrderedCollection new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
isEmpty 
	
	^items isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RaulBenitti 6/17/2012 12:19'!
items
	" Returns an Ordered Collection with the items in the cart"
	|anOrderCollectionOfItems|
	
	anOrderCollectionOfItems := OrderedCollection new. 
	items do:[ :anItem | anOrderCollectionOfItems add: anItem ].
	
	^anOrderCollectionOfItems! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:43'!
size
	
	^items size! !

!Cart methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:32'!
withItemsDo: aBlock
	
	items do: aBlock! !

Object subclass: #Cashier
	instanceVariableNames: 'listOfPrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:22'!
newWithListOfPrices: aListOfPrices
	
	^Cashier new initializeWithListOfPrices: aListOfPrices! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:22'!
charge: aCart with: aCreditCard
	
	| totalAmount |
	
	self verifyCartNotEmpty: aCart andDo: [
			self verifyCreditCardNotExpired: aCreditCard andDo: [
				totalAmount := 0.
				aCart withItemsDo: [:anItem | totalAmount := totalAmount + (self priceOf: anItem)].
				self verifyValidOperationFor: aCreditCard amount: totalAmount andDo: [^totalAmount]
				] 	
			]! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:23'!
initializeWithListOfPrices: aListOfPrices
	
	 listOfPrices := aListOfPrices! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:23'!
isValidOperationFor: aCreditCard withAmount: anAmount
	
	^true! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:23'!
priceOf: anItem
	
	^listOfPrices at: anItem! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:23'!
verifyCartNotEmpty: aCart andDo: aBlock
	
	(aCart isEmpty)
		ifTrue: [Error signal: 'No se puede cobrar un carrito vacio']
		ifFalse: aBlock! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:31'!
verifyCreditCardNotExpired: aCreditCard andDo: aBlock
	
	(aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: (Date current monthIndex) of: (Date current year)))
		ifTrue: [self error: 'No se puede cobrar con una tarjeta de credito vencida']
		ifFalse: aBlock! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'benitti 6/18/2012 18:23'!
verifyValidOperationFor: aCreditCard amount: anAmount andDo: aBlock
	
	(self isValidOperationFor: aCreditCard withAmount: anAmount)
		ifTrue: aBlock
		ifFalse: [Error signal: 'Operacion con la tarjeta de credito rechazada']
					
				! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'carts' stamp: 'RaulBenitti 6/17/2012 12:20'!
aCatalog
	| catalog |
	
	catalog:= Set new.
	catalog 
		add: 1;
		add: 'Book10';
		add: 'Book11'; 
		add: 'Book12';
		add: 'Book20';
		add: 'Book21'; 
		add: 'Book22';
		add: 'Book30';
		add: 'Book31'; 
		add: 'Book32'.
	^catalog! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book1FromEditorial1 

	^'Book10'! !

!TusLibrosTest methodsFor: 'books' stamp: 'RaulBenitti 6/17/2012 11:43'!
book1FromEditorial2 

	^'Book20'! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book2FromEditorial1 

	^'Book11'! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/17/2012 19:30'!
cartFromEditorial2 
	
	^Cart newWithListOfPrices: self listOfBooks2.! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:28'!
cartWithBook1 
	
	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1.
	^cart! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:30'!
cartWithTwoBooksFromEditorial1 
	
	| cart |
	
	cart := Cart newWithCatalog:  self catalog1.
	cart add: (self book1FromEditorial1) withOccurrences: 4.
	cart add: (self book2FromEditorial1) withOccurrences: 3.
	
	^cart! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:24'!
cashier
	
	^Cashier newWithListOfPrices: self listOfPrices1! !

!TusLibrosTest methodsFor: 'creditcards' stamp: 'benitti 6/18/2012 18:31'!
catalog1
	| catalog |
	
	catalog:= Set new.
	catalog add: 'Book10'; add: 'Book11'.
	^catalog! !

!TusLibrosTest methodsFor: 'carts' stamp: 'RaulBenitti 6/17/2012 11:59'!
collectionOfItems
	| aCollection |
	
	aCollection := OrderedCollection new.
	aCollection 
		add: 1;
		add: 'book01';
		add: 'book11'.
		
	^aCollection! !

!TusLibrosTest methodsFor: 'carts' stamp: 'RaulBenitti 6/17/2012 12:13'!
collectionOfItemsInCatalog
	| aCollection |
	
	aCollection := OrderedCollection new.
	aCollection 
		add: 'book11';
		add: 'book12';
		add: 'book20';
		add: 'book21'.		
	^aCollection! !

!TusLibrosTest methodsFor: 'carts' stamp: 'RaulBenitti 6/17/2012 11:48'!
emptyCart 
	
	^Cart newWithCatalog: self aCatalog.! !

!TusLibrosTest methodsFor: 'creditcards' stamp: 'benitti 6/18/2012 18:24'!
expiredCreditCard 
	
	^CreditCard ownedBy: 'Owner' identifiedBy: 1111 expiresOn: (MonthOfYear januaryOf: (Date current year - 1))
 
 ! !

!TusLibrosTest methodsFor: 'carts' stamp: 'RaulBenitti 6/17/2012 12:24'!
itemNotInCatalog 
	
	^'anItemNotInCatalog'.! !

!TusLibrosTest methodsFor: 'books' stamp: 'RaulBenitti 6/17/2012 11:38'!
listOfBooks2
	| books |
	
	books := Set new.
	^books 
		add: 'book20'; 
		add: 'book21';
		yourself.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'benitti 6/18/2012 18:28'!
listOfPrices1 
	| listOfPrices |
	
	listOfPrices:= Dictionary new.
	listOfPrices at: 'Book10' put: 10; at: 'Book11' put: 20.
	^listOfPrices! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:24'!
test01NewCartShouldBeEmpty

	self assert: self emptyCart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'RaulBenitti 6/17/2012 11:22'!
test02CanAddAnItemFromTheCatalog

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 withOccurrences:1.
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'RaulBenitti 6/17/2012 11:48'!
test03CannotAddAnItemNotInTheCatalog
	
	| anEmptyCart |
	
	anEmptyCart := self emptyCart.
	self should: [anEmptyCart add: self itemNotInCatalog] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Item is not present in the catalog. It cannot be added.'.
							self assert: anEmptyCart isEmpty 
							]! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:40'!
test04CanAddItemsInTheCatalogWithMoreThanOneOccurrence

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 withOccurrences: 2.
	self assert: cart size = 2 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:45'!
test04CannotAddItemsNotInTheCatalogWithMoreThanOneOccurrence

	| cart |
	
	cart := self emptyCart.
	
	self should: [cart add: self itemNotInCatalog  withOccurrences: 2.] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Item is not present in the catalog. It cannot be added.'.
							self assert: cart size = 0.
						].
	
! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:46'!
test05CannotAddItemsInTheCatalogWithLessThanOneOccurrence
	
	| aCart |
	
	aCart := self emptyCart.
	self should: [ aCart add: self book1FromEditorial1 withOccurrences: 0] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Invalid number of occurrences. It cannot be added.'.
							self assert: aCart isEmpty 
						].
	self should: [ aCart add: self book1FromEditorial1 withOccurrences: -2]
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Invalid number of occurrences. It cannot be added.'.
							self assert: aCart isEmpty 
						].! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:47'!
test05CannotAddItemsnotInCatalogWithLessThanOneOccurrence
	
	| aCart |
	
	aCart := self emptyCart.
	self should: [ aCart add: self itemNotInCatalog withOccurrences: 0] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Invalid number of occurrences. It cannot be added.'.
							self assert: aCart isEmpty 
						].
	self should: [ aCart add: self itemNotInCatalog withOccurrences: -2]
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'Invalid number of occurrences. It cannot be added.'.
							self assert: aCart isEmpty 
						].! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:39'!
test06OccurrencesOfItemNoInCartIsZero

	self assert: (self emptyCart amountOf: 'Book10') = 0 
! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'RaulBenitti 6/17/2012 12:29'!
test07CartHasACorrectAmountOfItems

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 withOccurrences: 4.
	cart add: self book1FromEditorial1 withOccurrences: 3.
	
	self assert: (cart amountOf: self book1FromEditorial1) = 7. 
 
	cart add: self book1FromEditorial2 withOccurrences: 3.
	
	self assert: (cart size) = 10. 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:49'!
test07TheCorrectAmountOfItemsIsAddedToTheCart

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 withOccurrences: 4.
	cart add: self book1FromEditorial1 withOccurrences: 3.
	
	self assert: (cart amountOf:   self book1FromEditorial1) = 7. 
 
	cart add: self book1FromEditorial2 withOccurrences: 3.
	
	self assert: (cart amountOf:  self book1FromEditorial2) = 3.
	self assert: (cart size) = 10. 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'benitti 6/18/2012 18:50'!
test09CartCorrectlyListTheAddedItems

	| aCart  |
	
	aCart := self emptyCart.
	
	self aCatalog  do:[ :anItem |
			aCart add: anItem].
	aCart items do:[ :anItem |
			self assert: ((self aCatalog ) includes: anItem )] 
	! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'RaulBenitti 6/17/2012 12:21'!
test09TwoNewCartsShouldBeEquals

	self assert: (self emptyCart = self emptyCart)! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:23'!
test10ACashierCannotChargeAnEmpyCart
	
	self should: [self cashier charge: self emptyCart with: self validCreditCard] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'No se puede cobrar un carrito vacio'.
							"Verificar que no se cobro nada" 
						].! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:24'!
test11ACashierCannotChargeACartWithAnExpiredCreditCard
	
	self should: [self cashier charge: self cartWithBook1 with: self expiredCreditCard] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'No se puede cobrar con una tarjeta de credito vencida'.
							"Verificar que no se cobro nada y que no interfaceo con la interface de la tarjeta" 
						].! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:24'!
test12AmountOfChargeACartWithMoreThanOneItemIsCorrect
	
	self assert: (self cashier charge: self cartWithTwoBooksFromEditorial1 with: self validCreditCard) = 100! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'benitti 6/18/2012 18:24'!
test13AmountOfChargeACartWithOneItemIsCorrect
	
	self assert: (self cashier charge: self cartWithBook1 with: self validCreditCard) = 10! !

!TusLibrosTest methodsFor: 'creditcards' stamp: 'benitti 6/18/2012 18:24'!
validCreditCard 
	
	^CreditCard ownedBy: 'Owner' identifiedBy: 1111 expiresOn: (MonthOfYear januaryOf: (Date current year + 1))
 ! !
